﻿local L = AceLibrary("AceLocale-2.2"):new("GridStatusMending")
local GridRoster = GridRoster

local spellNameMending = GetSpellInfo(36968)
local spellNamePrayerOfMending = GetSpellInfo(41635)

GridStatusMending = GridStatus:NewModule("GridStatusMending")
local GridStatusMending = GridStatusMending
GridStatusMending.menuName = spellNameMending

L:RegisterTranslations("enUS", function()
	return {
		["Mending Stack"] = true,
		["Mending Duration"] = true,

		["Color 1"] = true,
		["Color 2"] = true,
		["Color 3"] = true,
		["Color 4"] = true,
		["Color 5"] = true,

		["Color when player has one counter of mending."] = true,
		["Color when player has two counters of mending."] = true,
		["Color when player has three counters of mending."] = true,
		["Color when player has four counters of mending."] = true,
		["Color when player has five counters of mending."] = true,

		["Global Cooldown Mode"] = true,
		["Global Cooldown Duration"] = true,
		["Global Cooldown Delay"] = true,
	}
end)

L:RegisterTranslations("koKR", function()
	return {
		["Mending Stack"] = "회기 중첩",
		["Mending Duration"] = "회기 지속시간",

		["Color 1"] = "색상 1",
		["Color 2"] = "색상 2",
		["Color 3"] = "색상 3",
		["Color 4"] = "색상 4",
		["Color 5"] = "색상 5",

		["Color when player has one counter of mending."] = "플레이어에 회복의 기원 1 중첩시 색상",
		["Color when player has two counters of mending."] = "플레이어에 회복의 기원 2 중첩시 색상",
		["Color when player has three counters of mending."] = "플레이어에 회복의 기원 3 중첩시 색상",
		["Color when player has four counters of mending."] = "플레이어에 회복의 기원 4 중첩시 색상",
		["Color when player has five counters of mending."] = "플레이어에 회복의 기원 5 중첩시 색상",

		["Global Cooldown Mode"] = "재사용 대기시간 모드",
		["Global Cooldown Duration"] = "재사용 대기시간 지속시간",
		["Global Cooldown Delay"] = "재사용 대기시간 지연",
	}
end)

GridStatusMending.defaultDB = {
	debug = false,
	alert_MendingStack = {
		text = L["Mending Stack"],
		enable = true,
		color = { r = 0, g = 1, b = 1, a = 1 },
		color2 = { r = .5, g = .75, b = 0, a = 1 },
		color3 = { r = 1, g = .5, b = 0, a = 1 },
		color4 = { r = 1, g = 1, b = 0, a = 1 },
		color5 = { r = 1, g = 0, b = 0, a = 1 },
		gcdMode = false,
		gcdDuration = 1.5,
		gcdDelay = 0.5,
		priority = 70,
		range = false,
	},
	alert_MendingDuration = {
		text = L["Mending Duration"],
		enable = true,
		color = { r = 1, g = 1, b = 0, a = 1 },
		color2 = { r = 0, g = 1, b = 1, a = 1 },
		color3 = { r = 0, g = 1, b = 0, a = 1 },
		color4 = { r = 0, g = 1, b = 0, a = 1 },
		color5 = { r = 0, g = 1, b = 0, a = 1 },
		priority = 70,
		range = false,
	},
}

local alert_MendingStackOptions = {
	["color2"] = {
		type = "color",
		order = 100,
		name = L["Color 2"],
		desc = L["Color when player has two counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingStack.color2
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingStack.color2
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color3"] = {
		type = "color",
		order = 101,
		name = L["Color 3"],
		desc = L["Color when player has three counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingStack.color3
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingStack.color3
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color4"] = {
		type = "color",
		order = 101,
		name = L["Color 4"],
		desc = L["Color when player has four counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingStack.color4
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingStack.color4
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color5"] = {
		type = "color",
		order = 101,
		name = L["Color 5"],
		desc = L["Color when player has five counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingStack.color5
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingStack.color5
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
}

local alert_MendingDurationOptions = {
	["color2"] = {
		type = "color",
		order = 100,
		name = L["Color 2"],
		desc = L["Color when player has two counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingDuration.color2
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingDuration.color2
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color3"] = {
		type = "color",
		order = 101,
		name = L["Color 3"],
		desc = L["Color when player has three counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingDuration.color3
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingDuration.color3
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color4"] = {
		type = "color",
		order = 101,
		name = L["Color 4"],
		desc = L["Color when player has four counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingDuration.color4
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingDuration.color4
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color5"] = {
		type = "color",
		order = 101,
		name = L["Color 5"],
		desc = L["Color when player has five counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingDuration.color5
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingDuration.color5
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["gcdMode"] = {
		type = "toggle",
		order = 102,
		name = L["Global Cooldown Mode"],
		desc = L["Global Cooldown Mode"]..".",
		get = function ()
			return GridStatusMending.db.profile.alert_MendingStack.gcdMode
		end,
		set = function (arg)
			GridStatusMending.db.profile.alert_MendingStack.gcdMode = arg
		end,
	},
	["gcdDuration"] = {
		type = "range",
		order = 103,
		name = L["Global Cooldown Duration"],
		desc = L["Global Cooldown Duration"]..".",
		min = 1.5,
		max = 2,
		step = 0.01,
		disabled = function()
			if GridStatusMending.db.profile.alert_MendingStack.gcdMode then
				return false
			else
				return true
			end
		end,
		get = function ()
			return GridStatusMending.db.profile.alert_MendingStack.gcdDuration
		end,
		set = function (arg)
			GridStatusMending.db.profile.alert_MendingStack.gcdDuration = arg
		end,
	},
	["gcdDelay"] = {
		type = "range",
		order = 104,
		name = L["Global Cooldown Delay"],
		desc = L["Global Cooldown Delay"]..".",
		min = 0,
		max = 1,
		step = 0.01,
		disabled = function()
			if GridStatusMending.db.profile.alert_MendingStack.gcdMode then
				return false
			else
				return true
			end
		end,
		get = function ()
			return GridStatusMending.db.profile.alert_MendingStack.gcdDelay
		end,
		set = function (arg)
			GridStatusMending.db.profile.alert_MendingStack.gcdDelay = arg
		end,
	}
}

local format = string.format

function GridStatusMending:OnInitialize()
	self.super.OnInitialize(self)

	self:RegisterStatuses()
end

function GridStatusMending:OnEnable()
	self.debugging = self.db.profile.debug
	self:Debug("OnEnable")

	self.super.OnEnable(self)
end

function GridStatusMending:Reset()
	self.super.Reset(self)

	self:UnregisterStatuses()
	self:RegisterStatuses()
	self:UpdateAllUnits()
end


function GridStatusMending:RegisterStatuses()
	self:RegisterStatus("alert_MendingStack", L["Mending Stack"], alert_MendingStackOptions)
	self:RegisterStatus("alert_MendingDuration", L["Mending Duration"], alert_MendingDurationOptions)
end

function GridStatusMending:UnregisterStatuses()
	self:UnregisterStatus("alert_MendingStack")
	self:UnregisterStatus("alert_MendingDuration")
end


function GridStatusMending:Grid_UnitJoined(guid, unitid)
	self:UpdateUnit(unitid)
end

function GridStatusMending:UpdateAllUnits()
	for guid, unitid in GridRoster:IterateRoster() do
		self:UpdateUnit(unitid)
	end
end


-- expirationTimeList[guid] = expirationTime
-- colorList[guid] = color
local activeCount = 0
local expirationTimeList = {}
local colorList = {}

function GridStatusMending:RefreshActiveUnits()
	local settings = self.db.profile.alert_MendingDuration
	local now = GetTime()
	activeCount = 0

	for guid, expirationTime in pairs(expirationTimeList) do
		if (expirationTime > now) then
			local timeLeft = expirationTime - now
			local color = colorList[guid]
			activeCount = activeCount + 1

			if (timeLeft < 0) then
				timeLeft = 0
			end

			if settings.gcdMode then
				local gcd_count = (timeLeft - settings.gcdDelay) / settings.gcdDuration
				if (gcd_count < 0) then
					gcd_count = 0
				end
				local max_gcd_count = (7 - settings.gcdDelay) / settings.gcdDuration

				self.core:SendStatusGained(guid, "alert_MendingDuration",
										   settings.priority,
										   (settings.range and 40),
										   color,
										   format("%.1f", gcd_count),
										   gcd_count,
										   max_gcd_count)
			else
				self.core:SendStatusGained(guid, "alert_MendingDuration",
										   settings.priority,
										   (settings.range and 40),
										   color,
										   format("%.1f", timeLeft),
										   timeLeft,
										   6)
			end
		else
			expirationTimeList[guid] = nil
			colorList[guid] = nil

			self.core:SendStatusLost(guid, "alert_MendingDuration")
		end
	end

	-- Cancel repeating event when buff count reaches 0
	if (activeCount == 0) then
		self:CancelScheduledEvent("GridMending_Refresh")
	end
end


local f = function()
	GridStatusMending:RefreshActiveUnits()
end

function GridStatusMending:UpdateUnit(unitid, ignoreRange)
	local guid = UnitGUID(unitid)
	if (not GridRoster:IsGUIDInRaid(guid)) then
		return
	end

	local settings = self.db.profile.alert_MendingStack
	local durationEnabled = self.db.profile.alert_MendingDuration.enable
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitAura(unitid, spellNamePrayerOfMending, nil, "HELPFUL|PLAYER")

	if (isMine and duration) then
		local startTime = expirationTime - duration

		local thecolor = settings.color
		if (count == 2) then
			thecolor = settings.color2
		elseif (count == 3) then
			thecolor = settings.color3
		elseif (count == 4) then
			thecolor = settings.color4
		elseif (count == 5) then
			thecolor = settings.color5
		end

		if (settings.enable) then
			self.core:SendStatusGained(guid, "alert_MendingStack",
									   settings.priority,
									   (settings.range and 40),
									   thecolor,
									   tostring(count),
									   count,
									   6,
									   icon,
									   startTime,
									   duration,
									   count)
		end

		-- update info for alert_MendingDuration
		expirationTimeList[guid] = expirationTime
		colorList[guid] = thecolor

		-- whenever activeCount is zero, we need to start the repeating event
		if (activeCount == 0 and durationEnabled) then
			self:ScheduleRepeatingEvent("GridMending_Refresh", f, 0.07)
			self:RefreshActiveUnits()
		end
	else
		self.core:SendStatusLost(guid, "alert_MendingStack")
		if (durationEnabled) then
			self.core:SendStatusLost(guid, "alert_MendingDuration")
		end

		-- update info for alert_MendingDuration
		expirationTimeList[guid] = nil
		colorList[guid] = nil
	end
end


function GridStatusMending:EnabledStatusCount()
	local enabledStatusCount = 0

	for status, settings in pairs(self.db.profile) do
		if (type(settings) == "table" and settings.enable) then
			enabledStatusCount = enabledStatusCount + 1
		end
	end

	return enabledStatusCount
end

function GridStatusMending:OnStatusEnable(status)
	self:RegisterEvent("Grid_UnitJoined")
	self:RegisterEvent("UNIT_AURA", "UpdateUnit")

	if (status == "alert_MendingDuration") then
		activeCount = 0
	end

	self:UpdateAllUnits()
end

function GridStatusMending:OnStatusDisable(status)
	self.core:SendStatusLostAllUnits(status)
	self:UpdateAllUnits()

	if (self:EnabledStatusCount() == 0) then
		self:UnregisterEvent("Grid_UnitJoined")
		self:UnregisterEvent("UNIT_AURA")
	end

	if (status == "alert_MendingDuration") then
		self:CancelScheduledEvent("GridMending_Refresh")
	end
end
